//+------------------------------------------------------------------+
//|                                     MACD_ColorHist_Alert_EMA.mq4 |
//|                                     Copyright ?2006 |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright ?2006"
//---- indicator settings
#include <MovingAverages.mqh>

#property  indicator_separate_window
#property  indicator_buffers 6
#property indicator_plots   6


#property indicator_type1   DRAW_HISTOGRAM
#property indicator_type2   DRAW_HISTOGRAM
#property indicator_type3   DRAW_HISTOGRAM
#property indicator_type4   DRAW_HISTOGRAM
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE


#property  indicator_color1  LimeGreen
#property  indicator_color2  Orange
#property  indicator_color3  Green
#property  indicator_color4  Red
#property  indicator_color5  White
#property  indicator_color6  Red

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 1


//---- indicator parameters



input int FastEMA =5;  
input int SlowEMA =35;  
input int SignalEMA=5;  

//extern int  OsmaMultiplier =1;
input bool ShowHistogram  = true;
input bool ShowMACDLine   = true;
input bool ShowSignalLine = true;

input bool SoundAlert =true;
input bool EmailAlert  =false;
input bool MACDzeroLineCrossAlert   = true;
input bool MACDSignalLineCrossAlert = true;
input bool MACDDirectionChangeAlert = true;
input bool TwoBarsDirChageConfirm   = false;
input bool ShowAlertStatus = true;
input bool ChangeColorsOnSignalCross = false;
//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];


double HistogramBufferUp[];
double HistogramBufferDown[];

double HistogramBufferUp1[];
double HistogramBufferDown1[];

int flagval11 = 0;
int flagval12 = 0;
int flagval21 = 0;
int flagval22 = 0;
int flagval31 = 0;
int flagval32 = 0;
int flagval41 = 0;
int flagval42 = 0;

//---- variables
int MAf,MAs;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---- drawing settings
//   IndicatorBuffers(3);
	IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
   //SetIndexBuffer(0,HistogramBufferUp);//lime
   //SetIndexBuffer(1,HistogramBufferDown);//red
   //SetIndexBuffer(2,HistogramBufferUp1);//green
   //SetIndexBuffer(3,HistogramBufferDown1);//maroon
   //SetIndexBuffer(5,ind_buffer2);//yellow

   ArraySetAsSeries(HistogramBufferUp,true); 
   ArraySetAsSeries(HistogramBufferDown,true); 
   ArraySetAsSeries(HistogramBufferUp1,true); 
   ArraySetAsSeries(HistogramBufferDown1,true); 
   ArraySetAsSeries(ind_buffer1,true); 
   ArraySetAsSeries(ind_buffer2,true); 




if(ShowMACDLine)
    {
   //SetIndexStyle(4,DRAW_LINE);
   //SetIndexDrawBegin(4,SlowEMA);
   SetIndexBuffer(4,ind_buffer1,INDICATOR_DATA);
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,SlowEMA);
    }
 else
    {
    //SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,ind_buffer1,INDICATOR_CALCULATIONS);
    PlotIndexSetInteger(4,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(4,PLOT_LINE_COLOR,clrNONE); 
    }

if(ShowSignalLine)
    {
   //SetIndexStyle(5,DRAW_LINE);
   //SetIndexDrawBegin(5,SignalEMA);
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,SignalEMA);
   SetIndexBuffer(5,ind_buffer2,INDICATOR_DATA);
    }
 else
    {
    //SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,ind_buffer2,INDICATOR_CALCULATIONS);
    PlotIndexSetInteger(5,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(5,PLOT_LINE_COLOR,clrNONE); 
    }
 
 
 if(ShowHistogram)
   {
   //SetIndexStyle(0,DRAW_HISTOGRAM);
   //SetIndexStyle(1,DRAW_HISTOGRAM);
   //SetIndexStyle(2,DRAW_HISTOGRAM);
   //SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(0,HistogramBufferUp,INDICATOR_DATA);
   SetIndexBuffer(1,HistogramBufferDown,INDICATOR_DATA);
   SetIndexBuffer(2,HistogramBufferUp1,INDICATOR_DATA);
   SetIndexBuffer(3,HistogramBufferDown1,INDICATOR_DATA);    
   }
 else
    {
   //SetIndexStyle(0,DRAW_NONE);
   //SetIndexStyle(1,DRAW_NONE);
   //SetIndexStyle(2,DRAW_NONE);
   //SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(0,HistogramBufferUp,INDICATOR_CALCULATIONS);
   SetIndexBuffer(1,HistogramBufferDown,INDICATOR_CALCULATIONS);
   SetIndexBuffer(2,HistogramBufferUp1,INDICATOR_CALCULATIONS);
   SetIndexBuffer(3,HistogramBufferDown1,INDICATOR_CALCULATIONS);
    PlotIndexSetInteger(0,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(1,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(2,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(3,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(0,PLOT_LINE_COLOR,clrNONE); 
    PlotIndexSetInteger(1,PLOT_LINE_COLOR,clrNONE); 
    PlotIndexSetInteger(2,PLOT_LINE_COLOR,clrNONE); 
    PlotIndexSetInteger(3,PLOT_LINE_COLOR,clrNONE); 
    
   }


//   SetIndexDrawBegin(2,SlowEMA + SignalEMA);
//---- name for DataWindow and indicator subwindow label

   if (ShowAlertStatus)
   {
   string _SoundAlert="",_EmailAlert="";
   if(SoundAlert) _SoundAlert="ON";
   if(!SoundAlert)_SoundAlert="OFF";
   if(EmailAlert) _EmailAlert="ON";
   if(!EmailAlert)_EmailAlert="OFF";
   }
   //IndicatorShortName("MACDHist_Alert ("+FastEMA+","+SlowEMA+","+SignalEMA+") ");
   IndicatorSetString(INDICATOR_SHORTNAME,"MACDHist_Alert ("+FastEMA+","+SlowEMA+","+SignalEMA+") ");

   /*SetIndexLabel(4,"MACD");
   SetIndexLabel(5,"Signal");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");*/
   
	PlotIndexSetString(4,PLOT_LABEL,"MACD");
	PlotIndexSetString(5,PLOT_LABEL,"Signal");
	PlotIndexSetString(0,PLOT_LABEL," ");
	PlotIndexSetString(1,PLOT_LABEL," ");
	PlotIndexSetString(2,PLOT_LABEL," ");
	PlotIndexSetString(3,PLOT_LABEL," ");
       PlotIndexSetInteger(0,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(1,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(2,PLOT_SHOW_DATA,false);
    PlotIndexSetInteger(3,PLOT_SHOW_DATA,false);

//---- initialization done
     MAf = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE);
     MAs = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE);
  }
  
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   indicatorCalc(rates_total,prev_calculated,open,high,low,close); 

   return(rates_total);
}
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int indicatorCalc(int rates_total,int prev_calculated,
const double &open[],const double &high[],const double &low[],const double &close[])
{
   int limit,i;
   double temp,temp1;
   
   int counted_bars=prev_calculated;
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars(_Symbol,_Period)-counted_bars-2;
   
   
	double _maf[];
	ArraySetAsSeries(_maf, true);
	if (CopyBuffer(MAf,0,0,rates_total,_maf) < 0){Print("CopyBufferMAf error =",GetLastError());}
   
	double _mas[];
	ArraySetAsSeries(_mas, true);
	if (CopyBuffer(MAs,0,0,rates_total,_mas) < 0){Print("CopyBufferMAs error =",GetLastError());}
   
//---- macd counted in the 1-st buffer
   /*
   for(i=0; i<limit; i++)
      ind_buffer1[i]=_maf[i]-_mas[i];
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      ind_buffer2[i]=iMAOnArrayMQL4(ind_buffer1,Bars(_Symbol,_Period),SignalEMA,0,MODE_EMA,i);
*/
   for(i=0; i<limit; i++)
   {
      ind_buffer1[i]=_maf[i]-_mas[i];
      ind_buffer1[i+1]=_maf[i+1]-_mas[i+1];
      //ind_buffer2[i]=iMAOnArrayMQL4(ind_buffer1,i-1+(SignalEMA*2),SignalEMA,0,MODE_EMA,i);
      
      //ind_buffer2[i]= ExponentialMA(i,SignalEMA+1,ind_buffer2[i+1],ind_buffer1);
      ExponentialMAOnBuffer(i,SignalEMA,0,SignalEMA,ind_buffer1,ind_buffer2);

         //SimpleMAOnBuffer(rates_total,prev_calculated,0,InpSignalSMA,ExtMacdBuffer,ExtSignalBuffer);

      HistogramBufferUp[i]    = 0.0;//lime
      HistogramBufferDown[i]  = 0.0;//red
      HistogramBufferUp1[i]   = 0.0;//green
      HistogramBufferDown1[i] = 0.0;//maroon
       
//       if (OsmaMultiplier<=0)OsmaMultiplier=1;
//      temp =  ind_buffer1[i]*OsmaMultiplier;
//      temp1 = ind_buffer1[i+1]*OsmaMultiplier;
      
      bool up = ind_buffer1[i]>ind_buffer2[i];
         temp =  ind_buffer1[i];
         temp1 = ind_buffer1[i+1];

     
      if (ChangeColorsOnSignalCross)
      {
         if (up) 
         {
          if (temp>temp1)     //>0up
            {       
            HistogramBufferUp[i] = temp;    
            HistogramBufferDown1[i] = 0;  
            }
            else              //>0dn
            { 
            HistogramBufferUp [i] = 0.0;
            HistogramBufferUp1[i] = temp;   
            }
         }    
         else
         {  
            if (temp>temp1)     //<=0 up
            {       
            HistogramBufferDown[i] = temp; 
            HistogramBufferDown1[i] = 0;  
            }  
            else                  //<=0 dn
            {
            HistogramBufferDown[i] = 0.0;
            HistogramBufferDown1[i] = temp;  
           }
         }
      }
      else
      {      
         if (temp >0) 
         {
          if (temp>temp1)     //>0up
            {       
            HistogramBufferUp[i] = temp;    
            }
            else              //>0dn
            { 
            HistogramBufferUp [i] = 0.0;
            HistogramBufferUp1[i] = temp;   
            }
         }    
         else
         {  
            if (temp>temp1)     //<=0 up
            {       
            HistogramBufferDown[i] = temp; 
            }  
            else                  //<=0 dn
            {
            HistogramBufferDown[i] = 0.0;
            HistogramBufferDown1[i] = temp;  
           }
         }
      }         
//-
     if (i == 1)
    {

         if ((ind_buffer1[i] > 0)&&(ind_buffer1[i+1] < 0))
         {
// macd Cross 0 up
         if (flagval11==0)
           {
           flagval11=1;
           flagval12=0;
           flagval32=1;
           if ((SoundAlert)&&(MACDzeroLineCrossAlert)) Alert (Symbol(),"  M",Period(), " MACD is crossed Up 0"); 
                if ((EmailAlert)&&(MACDzeroLineCrossAlert)) SendMail("MACD CrossedZero Up", "MACD CrossedZero Up, Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
          }
//
       else if ((ind_buffer1[i]<0 )&&(ind_buffer1[i+1] >0))
        {
//macd Cross 0 down
         if (flagval12==0)
         {
          flagval11=0;
          flagval12=1;
          if ((SoundAlert)&&(MACDzeroLineCrossAlert)) Alert (Symbol(),"  M",Period(), " MACD is crossed Down 0"); 
               if ((EmailAlert)&&(MACDzeroLineCrossAlert)) SendMail("MACD Crossed Zero Down","MACD CrossedZero Down, Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
         }
        }

//
       else if ((ind_buffer1[i] < ind_buffer2[i])&&(ind_buffer1[i+1] > ind_buffer2[i+1]))
         {
//Macd xSigDn
         if (flagval21==0)
           {
           flagval21=1;
           flagval22=0;
           flagval41=1;
           if ((SoundAlert)&&(MACDSignalLineCrossAlert)) Alert (Symbol(),"  M",Period(), " MACD Signal Line crossed & going Down"); 
                if ((EmailAlert)&&(MACDSignalLineCrossAlert)) SendMail("MACD xSignalLane & going Down", "MACD xSignalLane & going Down, Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
         }

       else if ((ind_buffer1[i] > ind_buffer2[i])&&(ind_buffer1[i+1] < ind_buffer2[i+1]))
         {
//Macd xSigUp
         if (flagval22==0)
           {
         flagval21=0;
           flagval22=1;
           if ((SoundAlert)&&(MACDSignalLineCrossAlert)) Alert (Symbol(),"  M",Period(), " MACD Signal Line crossed & going Up"); 
                if ((EmailAlert)&&(MACDSignalLineCrossAlert)) SendMail("MACD xSignalLane & going Up", "MACD xSignalLane & going Up, Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
         }



// 
       else if  (((ind_buffer1[i]>0)&&(ind_buffer1[i] < ind_buffer1[i+1])&&(ind_buffer1[i+1] < ind_buffer1[i+2])&&(TwoBarsDirChageConfirm))||
                 ((ind_buffer1[i]>0)&&(ind_buffer1[i] < ind_buffer1[i+1])&&(!TwoBarsDirChageConfirm)))
         {
// >0dn
         if (flagval31==0)
           {
           flagval31=1;
           flagval32=0;
           if ((SoundAlert)&&(MACDDirectionChangeAlert)) Alert (Symbol(),"  M",Period(), " MACD>0 is Declining...... "); 
                if ((EmailAlert)&&(MACDDirectionChangeAlert)) SendMail("MACD Declining...", "MACD fDeclining.., Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
         }

       else if (((ind_buffer1[i]>0)&&(ind_buffer1[i] > ind_buffer1[i+1])&&(ind_buffer1[i+1] > ind_buffer1[i+2])&&(TwoBarsDirChageConfirm))||
                ((ind_buffer1[i]>0)&&(ind_buffer1[i] > ind_buffer1[i+1])&&(!TwoBarsDirChageConfirm)))
         {
// >0up
         if (flagval32==0)
           {
           flagval31=0;
           flagval32=1;
           if ((SoundAlert)&&(MACDDirectionChangeAlert)) Alert (Symbol(),"  M",Period(), " MACD>0 is Rising...... "); 
                if ((EmailAlert)&&(MACDDirectionChangeAlert)) SendMail("MACD Rising...", "MACD Rising.., Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
         }
       else if (((ind_buffer1[i]<=0)&&(ind_buffer1[i] < ind_buffer1[i+1])&&(ind_buffer1[i+1] < ind_buffer1[i+2])&&(TwoBarsDirChageConfirm))||
                ((ind_buffer1[i]<=0)&&(ind_buffer1[i] < ind_buffer1[i+1])&&(!TwoBarsDirChageConfirm)) )
         {
// <0dn
         if (flagval41==0)
           {
           flagval41=1;
           flagval42=0;
           if ((SoundAlert)&&(MACDDirectionChangeAlert)) Alert (Symbol(),"  M",Period(), " MACD<0 is Declining...... "); 
                if ((EmailAlert)&&(MACDDirectionChangeAlert)) SendMail("MACD Declining...", "MACD fDeclining.., Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
         }
//
       else if  (((ind_buffer1[i]<=0)&&(ind_buffer1[i] > ind_buffer1[i+1])&&(ind_buffer1[i+1] > ind_buffer1[i+2])&&(TwoBarsDirChageConfirm))||
                 ((ind_buffer1[i]<=0)&&(ind_buffer1[i] > ind_buffer1[i+1])&&(!TwoBarsDirChageConfirm)))

         {
// <0up
         if (flagval42==0)
           {
           flagval41=0;
           flagval42=1;
           if ((SoundAlert)&&(MACDDirectionChangeAlert)) Alert (Symbol(),"  M",Period(), " MACD<0 is Rising...... "); 
                if ((EmailAlert)&&(MACDDirectionChangeAlert)) SendMail("MACD Rising...", "MACD Rising.., Date="+TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeHour(TimeCurrent())+":"+TimeMinute(TimeCurrent())+" Symbol="+Symbol()+" Period="+Period());
           }
         }
//

      }
//-

   }
//---- done
   return(0);
 }
 
int TimeMinute(datetime theTime)
{
   MqlDateTime stm;
   datetime tm=TimeCurrent(stm);
   //--- output date components
   /*Alert("Year: "        +(string)stm.year);
   Alert("Month: "      +(string)stm.mon);
   Alert("Day: "      +(string)stm.day);
   Alert("Hour: "        +(string)stm.hour);
   Alert("Minute: "     +*/
   /*Alert("Second: "    +(string)stm.sec);
   Alert("Day of the week: "+(string)stm.day_of_week);
   Alert("Day of the year: "  +(string)stm.day_of_year);*/
   return((int)stm.min);
}
int TimeHour(datetime theTime)
{
   MqlDateTime stm;
   datetime tm=TimeCurrent(stm);
   //--- output date components
   /*Alert("Year: "        +(string)stm.year);
   Alert("Month: "      +(string)stm.mon);
   Alert("Day: "      +(string)stm.day);
   Alert("Hour: "        +(string)stm.hour);
   Alert("Minute: "     +*/
   /*Alert("Second: "    +(string)stm.sec);
   Alert("Day of the week: "+(string)stm.day_of_week);
   Alert("Day of the year: "  +(string)stm.day_of_year);*/
   return((int)stm.hour);
}
string TimeToStr(datetime theTime,int notUsed)
{
   MqlDateTime stm;
   datetime tm=TimeCurrent(stm);
   //--- output date components
   /*Alert("Year: "        +(string)stm.year);
   Alert("Month: "      +(string)stm.mon);
   Alert("Day: "      +(string)stm.day);
   Alert("Hour: "        +(string)stm.hour);
   Alert("Minute: "     +*/
   /*Alert("Second: "    +(string)stm.sec);
   Alert("Day of the week: "+(string)stm.day_of_week);
   Alert("Day of the year: "  +(string)stm.day_of_year);*/
   return((string)stm.hour+":"+(string)stm.min);
}
double iMAOnArrayMQL4(double &array[],
                      int total,
                      int period,
                      int ma_shift,
                      int ma_method,
                      int shift)
  {
   double buf[],arr[];
   if(total==0) total=ArraySize(array);
   if(total>0 && total<=period) return(0);
   if(shift>total-period-ma_shift) return(0);
   switch(ma_method)
     {
      case MODE_SMA :
        {
         total=ArrayCopy(arr,array,0,shift+ma_shift,period);
         if(ArrayResize(buf,total)<0) return(0);
         double sum=0;
         int    i,pos=total-1;
         for(i=1;i<period;i++,pos--)
            sum+=arr[pos];
         while(pos>=0)
           {
            sum+=arr[pos];
            buf[pos]=sum/period;
            sum-=arr[pos+period-1];
            pos--;
           }
         return(buf[0]);
        }
      case MODE_EMA :
        {
         if(ArrayResize(buf,total)<0) return(0);
         double pr=2.0/(period+1);
         int    pos=total-2;
         while(pos>=0)
           {
            if(pos==total-2) buf[pos+1]=array[pos+1];
            buf[pos]=array[pos]*pr+buf[pos+1]*(1-pr);
            pos--;
           }
         return(buf[shift+ma_shift]);
        }
      case MODE_SMMA :
        {
         if(ArrayResize(buf,total)<0) return(0);
         double sum=0;
         int    i,k,pos;
         pos=total-period;
         while(pos>=0)
           {
            if(pos==total-period)
              {
               for(i=0,k=pos;i<period;i++,k++)
                 {
                  sum+=array[k];
                  buf[k]=0;
                 }
              }
            else sum=buf[pos+1]*(period-1)+array[pos];
            buf[pos]=sum/period;
            pos--;
           }
         return(buf[shift+ma_shift]);
        }
      case MODE_LWMA :
        {
         if(ArrayResize(buf,total)<0) return(0);
         double sum=0.0,lsum=0.0;
         double price;
         int    i,weight=0,pos=total-1;
         for(i=1;i<=period;i++,pos--)
           {
            price=array[pos];
            sum+=price*i;
            lsum+=price;
            weight+=i;
           }
         pos++;
         i=pos+period;
         while(pos>=0)
           {
            buf[pos]=sum/weight;
            if(pos==0) break;
            pos--;
            i--;
            price=array[pos];
            sum=sum-lsum+price*period;
            lsum-=array[i];
            lsum+=price;
           }
         return(buf[shift+ma_shift]);
        }
      default: return(0);
     }
   return(0);
  }